#include <iostream>  
using namespace std;


int factorial_iterative(int n)
{ // This takes a non-negative number n, and returns 1*2*3*....*(n-1)*n

	int result = 1;

	if (n < 0) {
		cout << "Sorry, only non-negative numbers please." << endl;
		return -1;
	}

	for (int i = 1; i <= n; i++)
	{
		result = result * i;
	}

	return result;
}

int factorial(int n)
{ // This takes a non-negative number n, and returns 1*2*3*....*(n-1)*n

	/* If we comment out the next two ifs, we can cause the process to "Run
	 * away" down the negative numbers, and because it is using memory for each
	 * recursive call it will eventually run out of resources. */
	if (n < 0) {
		cout << "Sorry, only non-negative numbers please." << endl;
		return -1;
	}

	if (n == 0) return 1;

	return n * factorial(n-1);
}

/*
 * factorial(5)
 *          5 * factorial(5-1)
 *          5 * factorial(4)
 *          		factorial(4) 
 *          			4*factorial(3) 
 *          			...
 *	          			1*factorial(0) 
 *					   1*1
 *
 * */

int main()  // function were execution begins
{
	int n;
	cout << "Input a number: " << endl;
	cin >> n;

	cout << "n = " << n << " and n! = " << factorial(n) << endl;


	return 0; // returning zero from main() indicates success
}




